#include <stdarg.h>
#include "headers/LOG_IO.h"


static char* msgs[] = {"/WARNING/","/ERROR/","/INFO/","/DEBUG/"};


CLogger::CLogger(int debug)
{
	m_nDebug = debug;
}

void CLogger::_LOG(StatusType type, char* idString, char* fmt, ...)
{
	bool enableOutput = false;

	if(m_nDebug!=0)
	{
		enableOutput = true;
	} 
	else if(m_nDebug==0 && (type==INFO || type==ERROR))
	{
		enableOutput = true;
	}

	if(enableOutput)
	{
		va_list argp;

		printf(msgs[type]);
		printf("%s", idString);
		va_start(argp,fmt);
		vprintf(fmt,argp);
		va_end(argp);
		printf("\n");
	}
}
