#include <stdio.h>
#include <string>
#include <iostream>

#include "headers/SHL_Interface.h"
#include "headers/SHL_StringTable_Error.h"
#include "headers/SHL_StringTable_Message.h"
#include "headers/SHL_StringTable_Commands.h"
#include "headers/SHL_StringTable_Constants.h"
#include "headers/SHL_ReturnCodes.h"
#include "../../Sort/QuickSort/SD_01.h"
#include "../../Sort/BubbleSort/SD_01.h"
#include "../../RandomQuote/headers/CRandomQuote.h"


using namespace std;


SHL_Interface::SHL_Interface(char* sUserName)
:SHL_BaseInterface(sUserName)
{
}

SHL_Interface::~SHL_Interface()
{
	history_clear();
}

int SHL_Interface::runShell()
{
	string	sInput;
	bool	bTerminate = false;

	printf(STRTBL_MSG_WELCOME, getUserName());

	while (!bTerminate)
	{
		cout << STRTBL_SHELLPROMPT;
		cin >> sInput;

		if ( stricmp(sInput.c_str(), STRTBL_CMD_EXIT) == 0 )
		{
			bTerminate = true;
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_HISTORY) == 0 )
		{
			history_display();
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_QUICKSORT) == 0 )
		{
			M::SD_01 sorter;
			sorter.goQuickSort();
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_BUBBLESORT) == 0 )
		{
			B::SD_01 sorter;
			sorter.goBubbleSort();
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_LISTCMDS) == 0 )
		{
			cout << STRTBL_COMMANDS;
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_WHOAMI) == 0 )
		{
			printf(STRTBL_MSG_WHOAMI, getUserName());
		}
		else if ( stricmp(sInput.c_str(), STRTBL_CMD_RANDOMQUOTE) == 0 )
		{
			CRandomQuote rq;
			cout << "\"" << rq.genRandomQuote() << "\"\n\n";
		}
		else
		{
			printf(STRTBL_MSG_CMD_NOT_FOUND, sInput.c_str());
		}

		history_add(sInput);
	}

	return RET_SUCCESS;
}

void SHL_Interface::history_clear()
{
	m_History.clear();
}

void SHL_Interface::history_display()
{
	for( int i=0; i<(int)m_History.size(); i++)
  	{
		cout << "\t" << m_History[i] << "\n";
	}
}

void SHL_Interface::history_add(string sInput)
{
	m_History.insert(m_History.begin(), sInput);
}
