
#include "SD_45.h"
#include <cstdio>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cassert>

using namespace std;
using namespace M4;

	SD_45::SD_45()
	{
	};

	SD_45::~SD_45(){};
	
	void SD_45::f_SD_45() 
	{
		int n = 65000;
		
	    int*  A = new int[n];
	    RandomizeVec(A, n);
//	    PrintVec(A, n);
	    cout << endl << endl;
	    QuickSort(A, n);
//	    PrintVec(A, n);
	    delete A;
	    return;
	};

	void SD_45::RandomizeVec(int V[], int len)
	{
	    time_t TimeInSeconds;
	    time( &TimeInSeconds );
	    srand((unsigned int)TimeInSeconds);
	    for (int i=0; i<len; i++) V[i]=rand();
	}

	void SD_45::PrintVec (const int V[], int len) {
	    for(int i=0; i<len; i++) {
	        cout << setw(7) << V[i];
	        if (i%10==9) cout << endl; else cout << " ";
	    }
	    cout << endl;
	}
	
	//===========================================
	void SD_45::Swap(int &x, int &y) { int temp=x; x=y; y=temp; }
	
	//===========================================
	void SD_45::QuickSort(int V[], int left, int right) {
	    if (left<right) {
	        if (V[left]>V[right]) Swap(V[left], V[right]);
	
	        // Following block rearranges the array into three sections
	        // a sublist A[left]..A[j-1] of values less than A[j]
	        // a sublist A[j]
	        // a sublist A[j+1]..A[right]
	        int p=V[left];
	        int    i=left;
	        int    j=right+1;
	        do {
	            do { i++; } while (V[i]<p);
	            do { j--; } while (V[j]>p);
	            if (i<j) Swap(V[i], V[j]);
	        } while (i<j);
	        Swap(V[j], V[left]);
	        
	        QuickSort(V, left, j-1);
	        QuickSort(V, j+1, right);
	    }
	}
	
	//===========================================
	void SD_45::QuickSort(int V[], int len) { QuickSort(V, 0, len-1); }
